<!-- 

developed with reference to the 
Simple METS Viewer
     Prepared for the LOC METS site by Leslie Myrick, 
     Digital Library Team, New York University Libraries
     leslie.myrick@nyu.edu
     2002 August 09 
-->

<!-- Adapted for TEI examples Ch. Wittern -->

<!-- Copyright (c) 2002 New York University
     Permission is hereby granted, without written agreement and without
     license or royalty fees, to use, copy, modify, and distribute this XSLT
     style sheet for any purpose, provided that the above copyright notice
     and the following two paragraphs appear in all copies of this
     document.

     IN NO EVENT SHALL NEW YORK UNIVERSITY BE LIABLE TO ANY PARTY
     FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
     ARISING OUT OF THE USE OF THIS COMPUTER FILE, EVEN IF NEW YORK
     UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
     DAMAGE.

     NEW YORK UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE COMPUTER
     FILE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND NEW YORK
     UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
     SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:METS="http://www.loc.gov/METS/" xmlns:xlink="http://www.w3.org/1999/xlink"
      xmlns:gdm="http://sunsite.berkeley.edu/GDM/" xmlns:adm="http://sunsite.berkeley.edu/ADM/"
      xmlns:moa2="http://sunsite.berkeley.edu/MOA2/" xmlns:dc="http://purl.org/dc/elements/1.1/"
      xmlns:tei="http://www.tei-c.org/ns/1.0" version="1.0">
      <xsl:import href="tree.xsl"/>
      <xsl:output encoding="utf-8"/>
      <xsl:strip-space elements="*"/>
      <!-- global div param that drives the linking to a particular div in the structMap -->
      <xsl:param name="div" select="0"/>
      <!-- the div param will be appended to this dynamically loaded parameter
     make sure you hardwire the filename in if you are using Opera or Mozilla  -->
      <xsl:param name="url"/>
      <!-- set up navigational variables -->
      <xsl:variable name="firstfile">
            <xsl:value-of select="$url"/>?div=1</xsl:variable>
      <xsl:variable name="lastfile">
            <xsl:value-of select="$url"/>?div=<xsl:value-of select="//METS:div/METS:div[position() =
                  last()]/@ORDER"/>
      </xsl:variable>
      <xsl:variable name="backfile">
            <xsl:value-of select="$url"/>?div=<xsl:value-of select="$div - 1"/>
      </xsl:variable>
      <xsl:variable name="nextfile">
            <xsl:value-of select="$url"/>?div=<xsl:value-of select="$div + 1"/>
      </xsl:variable>
      <xsl:variable name="tocfile">
            <xsl:value-of select="$url"/>?div=0</xsl:variable>
      <!-- there are more keys declared here than have been used    for future tweaks -->
      <!-- ref from FILEID -->
      <xsl:key name="fileref" match="//METS:file" use="@ID"/>
      <!-- ref from DMDID -->
      <xsl:key name="dmdSecref" match="METS:dmdSec" use="@ID"/>
      <!-- ref from ADMID  -->
      <xsl:key name="techref" match="METS:admSec/techMD" use="@ID"/>
      <!-- ROOT ELEMENT -->
      <xsl:template match="/">
            <xsl:apply-templates select="METS:mets"/>
      </xsl:template>
      <xsl:template match="METS:mets">
            <html>
                  <head>
                        <!--<link rel="stylesheet" type="text/css" href="METS.css"/>-->
                        <title>
                              <xsl:value-of select="$url"/>
                        </title>
                        <style> h1, h2, h3, h4 {font-family: tahoma;} h1.centered {font-family:
                              tahoma; text-align:center} h2.centered {font-family: tahoma;
                              text-align:center} h3.centered {font-family: tahoma;
                              text-align:center} p.centered {text-align:center} a
                              {font-family:verdana; color:996633; font-size:10pt;
                              text-decoration:none} a:hover {font-family:verdana; color:000099;
                              font-size:10pt; text-decoration:none} td {font-family:verdana;
                              color:000099; font-size:10pt}
                              <!-- from prettyprint for tree view --> #header { background-color:
                              #ccc; border-bottom: 3px solid black; padding: 0.5em; margin-bottom:
                              1em; } .indent { margin-left: 1em; } .spacer { width: 1em; } .expander
                              { cursor: pointer; -moz-user-select: none; vertical-align: top;
                              text-align: center; } .expander-closed > * > .expander-content {
                              display: none; } .comment { font-family: monospace; white-space: pre;
                              } .markup, .start-tag, .end-tag { color: blue } .attribute-name {
                              color: green } .attribute-value{ color: brown } .text { color: black
                        }</style>
                  </head>
                  <body bgcolor="FFFFFF">
                        <h2 style="font-family:arial; font-size: 14pt; color:000099">ChW METS Viewer:
                                    <xsl:value-of select="//METS:structMap/METS:div/@LABEL"/></h2>
                        <table  width="400"  align="center">
                                          <xsl:call-template name="parent"/>
                                          <xsl:call-template name="toc"/>
                        </table>
                        <br /><hr /><br />
                        <table border="1">
                                          <xsl:apply-templates
                                                select="//METS:structMap/METS:div/METS:div"/>
                        </table>
                  </body>
            </html>
      </xsl:template>
      <xsl:template name="parent">
            <xsl:for-each select="//METS:structMap/METS:div">
                  <xsl:call-template name="processParent"/>
            </xsl:for-each>
      </xsl:template>
      <xsl:template name="toc">
            <tr>
                  <td colspan="3" >
                        <p style="font-family:verdana; font-size:11pt; font-weight: 600;
                              color:000099">Contents</p>
                  </td>
            </tr>
            <tr>
                  <td colspan="3" >
                        <p style="font-family:verdana; font-size:11pt; color:000099">There are <font
                                    color="red">
                                    <xsl:value-of select="count(//METS:structMap/METS:div/METS:div)"
                                    />
                              </font> items:</p>
                  </td>
            </tr>
            <tr>
                  <td colspan="3" >
                        <xsl:for-each select="//METS:structMap/METS:div/METS:div">
                              <xsl:sort select="@ORDER"/>
                              <xsl:element name="a">
                                    <xsl:attribute name="href">#<xsl:value-of select="@ID"/>
                                    </xsl:attribute>
                                    <xsl:value-of select="@LABEL"/>
                              </xsl:element>
                              <br/>
                        </xsl:for-each>
                  </td>
            </tr>
      </xsl:template>
      <xsl:template name="nestedtoc">
            <tr>
                  <td colspan="2">
                        <p style="font-family:verdana; font-size:11pt; color:000099">Contents of
                                    <xsl:value-of select="@LABEL"/></p>
                  </td>
            </tr>
            <tr>
                  <td colspan="2">
                        <xsl:for-each select="child::METS:div">
                              <xsl:element name="a">
                                    <xsl:attribute name="href"><xsl:value-of select="$url"
                                                />?div=<xsl:value-of select="@ORDER"/>
                                    </xsl:attribute>
                                    <xsl:value-of select="@LABEL"/>
                              </xsl:element>
                              <br/>
                        </xsl:for-each>
                  </td>
            </tr>
      </xsl:template>
      <!-- DIVS -->
      <xsl:template match="//METS:div/METS:div">
            <table>
                  <xsl:call-template name="processDiv"/>
            </table>
      </xsl:template>
      <xsl:template name="processDiv">
            <!-- this template works using a series of keys to follow the node from the FILEID attribute of the fptr element in the structMap to the ID attribute for the file in the fileSec. The administrative metadata is available laterally thorugh another key as an attribute of file. From there it uses another set of keys (dmdSecref) to grab the descriptive metadata in the appropriate dmdSec  -->
            <table>
                  <tr><td><a name="{@ID}"/></td></tr>
                  <tr>
                  <td>
                        <tr>
                              <td colspan="2">
                                    <h3>
                                          <xsl:value-of select="@LABEL"/>
                                    </h3>
                              </td>
                        </tr>
                        <xsl:if test="METS:fptr">
                              <!-- first the png files-->
                              <tr>
                                    <td valign="top" align="left">
                                          <xsl:for-each
                                                select="METS:fptr[substring(key('fileref',@FILEID)/METS:FLocat/@xlink:href,
                                                string-length(key('fileref',@FILEID)/METS:FLocat/@xlink:href)-3)
                                                = '.png']">
                                                <xsl:message>Current file: <xsl:value-of
                                                  select="substring(key('fileref',@FILEID)/METS:FLocat/@xlink:href,
                                                  string-length(key('fileref',@FILEID)/METS:FLocat/@xlink:href)-3)"
                                                  /></xsl:message>

                                                <a>
                                                  <xsl:attribute name="href">
                                                  <xsl:value-of
                                                  select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"
                                                  />
                                                  </xsl:attribute>
                                                  <xsl:attribute name="target">_blank</xsl:attribute>
                                                      <xsl:attribute name="title">Click here for a large version of the image</xsl:attribute>
                                                                                                       <xsl:value-of
                                                  select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"
                                                  />
</a><br/>
                                                  <img>
                                                  <xsl:attribute name="src">
                                                  <xsl:value-of
                                                  select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"
                                                  />
                                                  </xsl:attribute>
                                                  <xsl:message>
                                                  <xsl:value-of
                                                  select="key('dmdSecref',key('fileref',@FILEID)/@DMDID)//gdm:dimensions/@HEIGHT"
                                                  />
                                                  </xsl:message>
                                                  <xsl:attribute name="width">
                                                  <xsl:value-of
                                                  select="(key('dmdSecref',key('fileref',@FILEID)/@DMDID)//gdm:dimensions/@WIDTH)
                                                  *
                                                  key('dmdSecref',key('fileref',@FILEID)/@DMDID)//gdm:dimensions/@SCALE"
                                                  />
                                                  </xsl:attribute>
                                                  <xsl:attribute name="height">
                                                  <xsl:value-of
                                                  select="(key('dmdSecref',key('fileref',@FILEID)/@DMDID)//gdm:dimensions/@HEIGHT)
                                                  *
                                                  key('dmdSecref',key('fileref',@FILEID)/@DMDID)//gdm:dimensions/@SCALE"
                                                  />
                                                  </xsl:attribute>
                                                  <!--
<xsl:value-of select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"/>-->
                                                  </img>
                                                <br/>
                                          </xsl:for-each>
                                    </td>
                                    <!-- for parallel alignin ignore this --> 
                              </tr>
                              <tr> -
                                    <td>
                                          <xsl:for-each
                                                select="METS:fptr[substring(key('fileref',@FILEID)/METS:FLocat/@xlink:href,
                                                string-length(key('fileref',@FILEID)/METS:FLocat/@xlink:href)-3)
                                                = '.xml']">
                                                <a>
                                                  <xsl:attribute name="href">
                                                  <xsl:value-of
                                                  select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"
                                                  />
                                                  </xsl:attribute>
                                                  <xsl:attribute name="target">new</xsl:attribute>
                                                  <xsl:value-of
                                                  select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"
                                                  />
                                                </a>
                                                <xsl:variable name="part" select="METS:area/@BEGIN"/>
                                                <xsl:message>part: <xsl:value-of select="$part"/></xsl:message>
                                                
                                                <xsl:variable name="teifile">
                                                      <xsl:choose>
                                                            <xsl:when test="string-length($part) = 0">
                                                      <xsl:copy-of
                                                  select="document(key('fileref',@FILEID)/METS:FLocat/@xlink:href)"
                                                  />
                                                                  
                                                            </xsl:when>
                                                            <xsl:otherwise>
                                                                                                                        <xsl:copy-of
                                                  select="document(key('fileref',@FILEID)/METS:FLocat/@xlink:href)//tei:*[@xml:id=$part]"
                                                  />

                                                            </xsl:otherwise>
                                                      </xsl:choose>
                                                      
                                                </xsl:variable>
                                                <xsl:apply-templates mode="tree" select="$teifile"/>
                                                <!--            <xsl:value-of select="$teifile"/> -->
                                          </xsl:for-each>
                                    </td>
                              </tr>
                        </xsl:if>
                        <tr>
                              <td colspan="2">&#x00A0;</td>
                        </tr>
                  </td>
</tr></table>
            <!--<xsl:if test="child::METS:div">
<xsl:call-template name="nestedtoc"/>
</xsl:if>
            <xsl:for-each select="child::METS:div">
                  <xsl:call-template name="processDiv"/>
            </xsl:for-each>
            -->
      </xsl:template>
      <xsl:template name="processParent">
            <tr>
                  <td valign="top">
                        <xsl:for-each select="METS:fptr">
                              <xsl:if
                                    test="substring(key('fileref',@FILEID)/METS:FLocat/@xlink:href,
                                    string-length(key('fileref',@FILEID)/METS:FLocat/@xlink:href)-3)
                                    = '.gif'">
                                    <xsl:variable name="fileID">
                                          <xsl:value-of select="@FILEID"/>
                                    </xsl:variable>
                                    <img>
                                          <xsl:attribute name="src">
                                                <xsl:value-of
                                                  select="key('fileref',@FILEID)/METS:FLocat/@xlink:href"
                                                />
                                          </xsl:attribute>
                                          <xsl:attribute name="border">none</xsl:attribute>
                                    </img>
                              </xsl:if>
                        </xsl:for-each>
                  </td>
                  <td>
                        <h3>
                              <xsl:value-of select="@LABEL"/>
                        </h3>
                        <!--<tr><td colspan="2"><h3><xsl:value-of select="@LABEL"/></h3></td></tr>-->
                        <xsl:if test="@DMDID">
                              <xsl:choose>
                                    <xsl:when test="key('dmdSecref',@DMDID)//moa2:localID">
                                          <tr>
                                                <td colspan="2"><h4 style="font-family:verdana;
                                                  font-size:10pt; color:000099">General
                                                  Descriptive Metadata</h4>
                                                  <b>Core Metadata:</b><br/> Local
                                                  Identifier:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:localID"
                                                  /><br/> Date:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:coreDate/@DATE"/><br/>
                                                  <xsl:for-each
                                                  select="key('dmdSecref',@DMDID)//moa2:altDate/@DATE"
                                                  > Alternate Date:<xsl:value-of
                                                  select="."/><br/>
                                                  </xsl:for-each> Dimensions (H x W x
                                                  D):<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:dimensions/@HEIGHT"
                                                  /> x <xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:dimensions/@WIDTH"
                                                  /> x <xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:dimensions/@DEPTH"
                                                  /><br/> Object Type:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:soType"/><br/><br/>
                                                  <b>Creator</b>:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:creator"
                                                  /> -- <b>Role</b>: <xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//moa2:creator/@ROLE"
                                                  /><br/>
                                                </td>
                                          </tr>
                                          <tr>
                                                <td colspan="2"><b>General Notes</b>:</td>
                                          </tr>
                                          <xsl:for-each
                                                select="key('dmdSecref',@DMDID)//moa2:general">
                                                <xsl:if test="@PUBLIC='true'">
                                                  <tr>
                                                  <td colspan="2">
                                                  <xsl:value-of select="."/>
                                                  </td>
                                                  </tr>
                                                </xsl:if>
                                          </xsl:for-each>
                                    </xsl:when>
                                    <xsl:when test="key('dmdSecref',@DMDID)//dc:title">
                                          <tr>
                                                <td colspan="2"><h4 style="font-family:verdana;
                                                  font-size:10pt; color:000099">General
                                                  Descriptive Metadata</h4>
                                                  <b>Core Metadata:</b><br/> Title:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//dc:title"/><br/>
                                                  <xsl:for-each
                                                  select="key('dmdSecref',@DMDID)//dc:date"
                                                  > Date:<xsl:value-of select="."/><br/>
                                                  </xsl:for-each> Object Type:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//dc:type"/><br/><br/>
                                                  <b>Creator</b>:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//dc:creator"
                                                  /><br/>
                                                </td>
                                          </tr>
                                          <tr>
                                                <td colspan="2"><b>Description</b>:</td>
                                          </tr>
                                          <xsl:for-each
                                                select="key('dmdSecref',@DMDID)//dc:description">
                                                <xsl:if test="@PUBLIC='true'">
                                                  <tr>
                                                  <td colspan="2">
                                                  <xsl:value-of select="."/>
                                                  </td>
                                                  </tr>
                                                </xsl:if>
                                          </xsl:for-each>
                                    </xsl:when>
                                    <xsl:when test="key('dmdSecref',@DMDID)//gdm:core">
                                          <tr>
                                                <td colspan="2"><h4 style="font-family:verdana;
                                                  font-size:10pt; color:000099">General
                                                  Descriptive Metadata</h4>
                                                  <b>Core Metadata:</b><br/> Local
                                                  Identifier:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:localID"
                                                  /><br/> Date:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:coreDate/@DATE"/><br/>
                                                  <xsl:for-each
                                                  select="key('dmdSecref',@DMDID)//gdm:altDate/@DATE"
                                                  > Alternate Date:<xsl:value-of
                                                  select="."/><br/>
                                                  </xsl:for-each> Dimensions (H x W x
                                                  D):<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:dimensions/@HEIGHT"
                                                  /> x <xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:dimensions/@WIDTH"
                                                  /> x <xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:dimensions/@DEPTH"
                                                  /><br/> Object Type:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:soType"/><br/><br/>
                                                  <b>Creator</b>:<xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:creator"
                                                  /> -- <b>Role</b>: <xsl:value-of
                                                  select="key('dmdSecref',@DMDID)//gdm:creator/@ROLE"
                                                  /><br/>
                                                </td>
                                          </tr>
                                          <tr>
                                                <td colspan="2"><b>General Notes</b>:</td>
                                          </tr>
                                          <xsl:for-each
                                                select="key('dmdSecref',@DMDID)//gdm:general">
                                                <xsl:if test="@PUBLIC='true'">
                                                  <tr>
                                                  <td colspan="2">
                                                  <xsl:value-of select="."/>
                                                  </td>
                                                  </tr>
                                                </xsl:if>
                                          </xsl:for-each>
                                    </xsl:when>
                              </xsl:choose>
                              <!--</xsl:for-each>-->
                        </xsl:if>
                        <tr>
                              <td colspan="2">&#x00A0;</td>
                        </tr>
                  </td>
            </tr>
      </xsl:template>
</xsl:stylesheet>
